<?php
/**
*
* @package acp
* @version $Id: acp_sitemap_generator.php 2007-11-26 Joshua2100 $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @package acp
*/
class acp_sitemap_generator
{
	var $u_action;
	var $new_config = array();
					
	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
		
		$user->add_lang('mods/info_acp_sitemap_generator');
		
		$this->tpl_name = 'acp_sitemap_generator';
		$this->page_title = 'ACP_SITEMAP_GENERATOR';
		
		// Set up general vars
		$submit	= isset($_POST['submit']) ? true : false;	
		require($phpbb_root_path . 'includes/sitemap_functions.' . $phpEx);
		
		$sql = 'SELECT config_name, config_value
				FROM ' . CONFIG_TABLE . '
				WHERE config_name = "map_zipped"
				OR config_name = "server_name"
				OR config_name = "script_path"
				OR config_name = "seo_mod"
				OR config_name = "ping_google"
				OR config_name = "show_stats"';
				
		$result = $db->sql_query($sql);
		$mysettings = array();
		while ($data = $db->sql_fetchrow($result))
		{
			$mysettings[$data['config_name']] = $data['config_value'];
		}
		$seomod = false;
		if ($mysettings['seo_mod'] == '1') 
		{
			$seoloc = $phpbb_root_path . 'includes/functions_seo.' . $phpEx;
			$seomod = true;
			if (file_exists($seoloc)) 
			{
				require_once($seoloc);
			}
		}
		define('FORUM_DOMAIN_ROOT', 'http://'.$mysettings['server_name'].$mysettings['script_path'].'/');
			
		if (($submit) && (isset($_POST['generate'])))
		{
			$report = array();
			// Sitemap Generator
			$zipped = false;
			if ($mysettings['map_zipped'] == '1') 
			{
			$zipped = true;
			}
			// Creating Topic SiteMap... 
			$topicmap = topic_map($seomod);
			$error = write_map($topicmap, 'topic', $zipped);
				
			// Creating Forum SiteMap...
			$forummap = forum_map($seomod);
			$error = write_map($forummap, 'forum', $zipped);
			
			// write index map
			$indexmap = map_index();
			$error = write_map($indexmap, 'index', $zipped);
			
			if ($error == true) 
			{
			trigger_error($user->lang['MAP_WRITE_FAIL'] . adm_back_link($this->u_action), E_USER_WARNING);
			}
			// Pinging Google SiteMaps...
			if ($mysettings['ping_google'] == '1') 
			{
				$smindex = FORUM_DOMAIN_ROOT.'sitemap_index.xml';
				pinggooglesitemaps($smindex);
			}
			
			// SiteMap Creation Complete.
			trigger_error($user->lang['GENERATE_COMPLETE'] . adm_back_link($this->u_action));
		}
		// lets get some pointless stats to display : D
		if ($mysettings['map_zipped'] != '1' && ($mysettings['show_stats'] == '1')) 
		{
			$topicmap = FORUM_DOMAIN_ROOT . 'topic_sitemap.xml';
			$forummap = FORUM_DOMAIN_ROOT . 'forum_sitemap.xml';
		 	$topicline = @substr_count(@file_get_contents($topicmap), '<loc>');
		 	$forumline = @substr_count(@file_get_contents($forummap), '<loc>');
			$topicsize = @filesize($topicmap) . ' bytes';
			$forumsize = @filesize($forummap) . ' bytes';
		  	$template->assign_vars(array(
				'TOPIC_LINKNO'		=> $topicline,
				'FORUM_LINKNO'		=> $forumline,
				'T_SHOW_TEHSTAT'	=> true,
				'TOPIC_SIZE'		=> $topicsize,
				'FORUM_SIZE'		=> $forumsize,
				'SM_LAST_RUN'		=> 'N/A',
				'SM_VERSION'		=> '1.0.0B2',
				)
			);
		}
		// start settings
		$display_vars = array(
				'title'	=> 'ACP_SITEMAP_GENERATOR_SETTINGS',
				'vars'	=> array(
				'legend'		=> 'SETTINGS',
				'ping_google'	=> array('lang' => 'PINGORNOT', 'type' => 'radio:yes_no', 'explain' => false),
				'seo_mod'		=> array('lang' => 'SEOMOD', 'type' => 'radio:yes_no', 'explain' => false),
				'map_zipped'	=> array('lang' => 'MAPZIP', 'type' => 'radio:yes_no', 'explain' => false),
				'show_stats'	=> array('lang' => 'SHOWSTAT', 'type' => 'radio:yes_no', 'explain' => false),
				)
			);
			
		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		$this->new_config = $config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);
		
		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

			if ($submit)
			{
				set_config($config_name, $config_value);
			}
		}

// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'CONTENT'		=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
				)
			);
		
			unset($display_vars['vars'][$config_key]);
		}
		
	}
}
?>